function [A,b,xtrue] = makeAbx( Problem,SPD );

% SPD=1; [A,b,xtrue] = makeAbx( Problem,SPD );
% SPD=0; [A,b,xtrue] = makeAbx( Problem,SPD );
% extracts A = Problem.A from a symmetric sparse matrix in SuiteSparse format,
% scales A, and creates b such that Ax = b has a known solution.
% SPD = 1 means A is symmetric positive definite.
% SPD = 0 means A is symmetric but may be indefinite.
    
% 29 Apr 2020: First version of makeAbx for testing minres with various preconditioners.
%              Michael Saunders, ICME, Stanford University.
% 06 May 2020: Revised to use different scaling for SPD and SID matrices.

  A      = Problem.A;
  n      = length(A);

  %%% Scale A to be exactly symmetric with norm(A,inf) = O(1).
  iprint = 1;
  if SPD==1
     [A,D] = scaleSPD( A,iprint );
  else
     [A,D] = scaleSID( A,iprint );
  end

  xtrue  = (n:-1:1)'/n;   % xtrue(1) = 1 (compare with x(1) printed by minres)
  b      = A*xtrue;

end % function makeABx
